const $__init__$ = Symbol.for('#__init__'), $__patch__$ = Symbol.for('#__patch__'), $__initor__$ = Symbol.for('#__initor__'), $__inited__$ = Symbol.for('#__inited__'), $__hooks__$ = Symbol.for('#__hooks__');
var $5 = Symbol();
Object.defineProperty(exports, "__esModule", {value: true});

/*body*/
var $1 = require('../Utils/got'/*$path$*/);
var $2 = require('../Records/DiscordRecord'/*$path$*/);
var $3 = require('@livy/contracts/lib/formatter-interface'/*$path$*/);
var $4 = require('@livy/util/lib/handlers/abstract-formatting-processing-handler'/*$path$*/);

class DiscordWebhookHandler extends $4.AbstractFormattingProcessingHandler {
	static [$__init__$](){
		this.prototype[$__initor__$] = $5;
		return this;
	}
	[$__patch__$]($$ = {}){
		var $6;
		super[$__patch__$] && super[$__patch__$]($$);
		($6 = $$._webhookUrl) !== undefined && (this._webhookUrl = $6);
		($6 = $$._discordRecord) !== undefined && (this._discordRecord = $6);
		
	}
	[$__init__$]($$ = null,deep = true){
		deep && super[$__init__$] && super[$__init__$](...arguments);
		this._webhookUrl = $$ ? $$._webhookUrl : undefined;
		this._discordRecord = $$ ? $$._discordRecord : undefined;
		
	}
	
	
	// Discord webhook url
	
	
	// Instance of DiscordRecord class preparing data for Discord API
	
	
	/**
	@param {string} webhookUrl
	*/
	constructor(webhookUrl,options = {}){
		
		super({level: options.level,bubble: options.bubble});
		
		super[$__init__$] || this[$__init__$]();
		this._webhookUrl = webhookUrl;
		this.explicitFormatter = options.formatter;
		
		this._discordRecord = new $2.DiscordRecord({
			username: options.username,
			useEmbed: options.useEmbed,
			avatarUrl: options.avatarUrl,
			includeContextAndExtra: options.includeContextAndExtra,
			excludedFields: options.excludedFields,
			formatter: this.explicitFormatter
		});
		this[$__initor__$]===$5 && (this[$__hooks__$]&&this[$__hooks__$].inited(this),this[$__inited__$] && this[$__inited__$]());
	}
	
	// Get the disocrd record associated with the handler
	/**
	@returns { DiscordRecord }
	*/
	get discordRecord(){
		
		return this._discordRecord;
	}
	
	// Get the handler's webhook URL
	/**
	@returns { string }
	*/
	get webhookUrl(){
		
		return this._webhookUrl;
	}
	
	// @inheritdoc
	/**
	@param {LogRecord} record
	@returns { Promise<void> }
	*/
	async write(record){
		
		const postData = this._discordRecord.getDiscordData(record);
		const postString = JSON.stringify(postData);
		
		await $1.got(this._webhookUrl,{
			method: 'POST',
			body: postString,
			headers: {
				'Content-Type': 'application/json'
			}
		});
		
		return null;
	}
	
	// @inheritdoc
	getDefaultFormatter(){
		
		return this._discordRecord.defaultFormatter;
	}
	
	// @inheritdoc
	/**
	@param {FormatterInterface} formatter
	*/
	setFormatter(formatter){
		
		return this._discordRecord.formatter = formatter;
	}
	
	// @inheritdoc
	getFormatter(){
		
		return this._discordRecord.formatter;
	}
};
exports.DiscordWebhookHandler = DiscordWebhookHandler; DiscordWebhookHandler[$__init__$]();
