Object.defineProperty(exports, "__esModule", {value: true});

/*body*/
var $1 = require('@formidablejs/framework'/*$path$*/);
var $2 = require('@livy/logger'/*$path$*/);
var $3 = require('./Exceptions/InvalidLogDriverException'/*$path$*/);
var $4 = require('./Exceptions/RegisteredLogDriverException'/*$path$*/);


// Registered channels
const registered = {};

// Available logger instances
const available = {};

// Register driver
/**
@param {string} name
@param {Driver } driver
@returns { void }
*/
function register(name,driver){
	
	if (registered[name]) {
		
		throw new $4.RegisteredLogDriverException(("Driver \"" + name + "\" is already registered"));
	};
	
	return registered[name] = driver;
};

// Get driver
/**
@param {string} name
*/
function get(name){
	
	if (!registered[name]) {
		
		throw new $3.InvalidLogDriverException(("Driver \"" + name + "\" is not registered"));
	};
	
	return registered[name];
};

/**
@param {string} name
*/
function getInstance(name){
	
	return available[name];
};

/**
@param {string} name
*/
function registerInstance(name,handler){
	
	return available[name] = handler;
};

let environment = 'local';
let loggingMode = 'sync';

try {
	
	environment = $1.config('app.env','local');
	loggingMode = $1.config('logging.mode','sync');
} catch (e) { };

// Instantiate logger
const Log = new $2.createLogger(environment,{
	mode: loggingMode
});

exports.getInstance = getInstance;
exports.registerInstance = registerInstance;
exports.get = get;
exports.Log = Log;
exports.register = register;
